=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

#export NORECOIL=1
export API=sdl2
export V=1

%:
	dh $@ --sourcedirectory=src
#	dh $@ --sourcedirectory=src -- depend

override_dh_auto_install:
	@echo Do not use install target of upstream Makefile

override_dh_auto_test:
	@echo Skip test
